<?php 
/******************************************************************************
* admin.php - Admin File                                                      *
*******************************************************************************
* phpCheckZ - The Easy Checklist Maker                                        *
* =========================================================================== *
* Software Version:           phpCheckZ 1.1.0                                 *
* Software by:                The RSWR Network (http://www.rswr.net)          *
* Copyright 2008 by:          Ryan Christenson (http://www.rswr.net)          *
* Support, News, Updates at:  http://www.phpcheckz.com/                       *
*******************************************************************************
* This program is free software; you can redistribute it and/or modify        *
* it under the terms of the GNU General Public License as published by        *
* the Free Software Foundation; either version 2 of the License, or           *
* (at your option) any later version.                                         *
*                                                                             *
* This program is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of              *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
* GNU General Public License for more details.                                *
*                                                                             *
* You should have received a copy of the GNU General Public License           *
* if not, write to the:                                                       *
* Free Software Foundation, Inc.                                              *
* 51 Franklin St - Fifth Floor, Boston, MA 02110-1301, USA                    *
******************************************************************************/
session_start();
ob_start();
?>
<?php include "constants.php" ?>
<?php include "db.php" ?>
<?php include "security.php" ?>
<?php include "functions.php" ?>
<?php include "language.php" ?>
<?php include "header.php" ?>
<?php
if (!ckz_IsLoggedIn() && (@$_COOKIE[CookieAutoLogin] == "autologin" && @$_COOKIE[CookiePassword] <> "")) {
	ob_end_clean();
	header("Location: login.php");
	exit();
}
ckz_LoadUserLevel();
$ckz_CurSec = (ckz_IsLoggedIn())? ckz_CurrentUserLevelPriv("listcreate") : ckz_GetAnonymousPriv("listcreate");	
if (($ckz_CurSec & ckz_Allow) <> ckz_Allow) {
	ob_end_clean();
	header("Location: login.php");
	exit();
}
if (ckz_IsLoggedIn() && ckz_CurrentUserID() == "") {
	ob_end_clean();
	header("Location: login.php");
	exit();
}
?>
<?php
if (@$_SESSION[ckzSessMessage] <> "") {
	echo '<p><div class="red">' . $_SESSION[ckzSessMessage] . '</div></p>';
	$_SESSION[ckzSessMessage] = "";
}
?>
<table class="table2Header bold"><tr><td><?php echo $Translation["cred_01"]; ?></td></tr></table>
	<table class="table2" style="padding:6px;">
		<input type="hidden" id="x_id" name="x_id" value="<?php echo @$x_id; ?>">
		<tr>
			<td>
<h2>Special Thanks</h2><br />
The RSWR Network would like to thank and give credit to the following people and/or organizations for their work that we integrated into the project.
<ol>
	<li><a href="http://jquery.com/">jQuery</a> - Many of phpCheckZ's javascript functions were created using the jQuery library.</li>
	<li><a href="http://trentrichardson.com/Impromptu/">jQuery Impromptu</a> - jQuery Impromptu is used for our message pop ups for sleeker design.</li>
	<li><a href="http://naku.dohcrew.com/libchart/">Libchart</a> - phpCheckZ's charts are powered by Libchart</li>
</ol>
<br /><h2>About phpCheckZ's Bridges</h2><br />
phpCheckZ uses various bridges to connect with other software's user control systems. We recommend visiting the sites listed below for more information.
<ol>
	<li><a href="http://www.simplemachines.org/">Simple Machines Forum (SMF)</a></li>
	<li><a href="http://www.phpbb.com/">phpBB Forum</a> - The most widely used open source forum solution.</li>
</ol>
			</td>
			<td></td>
		</tr>
	</table>
<?php include "footer.php" ?>
